-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
--Mandatory controller parameters
M.type = "auxiliary"
M.relevantDevice = nil

M.screenData = {}

local screenMaterialName = "@moonhwak_ammo_screen"
local htmlTexture = require("htmlTexture")
local data
local modes = {"Clock", "Temperature", "Ammunation"}
local modesLength = #modes

local numberOfRounds

local function nextScreen(pScreenIndex)
	if pScreenIndex == nil then
		local lLength = modesLength
		
		if (v.userPartConfig.moonhawk_guns == "none" or electrics.values.gundoors == 0) then
			lLength = lLength - 1
		end
		
		if M.screenData.mode < lLength then 
			M.screenData.mode = M.screenData.mode + 1
		else M.screenData.mode = 1 end
		
	else
		if pScreenIndex <= modesLength and pScreenIndex > 0 then 
			M.screenData.mode = pScreenIndex 
		end
	end
	
	gui.message("Screen info: " .. modes[M.screenData.mode], 3, "cannonrounds")
	htmlTexture.call(screenMaterialName, "refreshScreen", M.screenData)
end

local function updateAmmo(pRounds)
	M.screenData.roundsLeft = pRounds or 0
	if M.screenData.mode == 3 then htmlTexture.call(screenMaterialName, "refreshScreen", M.screenData) end
end

local function init()
  -- electrics.values.screenSwitch = 0
  htmlTexture.create(screenMaterialName, "local://local/vehicles/moonhawk/6x6_F/ammo_screen.html", 256, 128, 10, 'automatic')
  M.screenData = {
	roundsLeft = nil,
	-- gunState = 0,
	temp = obj:getEnvTemperature() -273.15,
	tempUnit = settings.getValue('uiUnitTemperature'),
	timeFormat = settings.getValue('uiUnitLength'),
	mode = 1,
  }
  
  htmlTexture.call(screenMaterialName, "refreshScreen", M.screenData)
end

M.init = init
M.nextScreen = nextScreen
M.updateAmmo = updateAmmo

return M